from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, String

Umi_Reformat_Fastq_V0_1_0 = CommandToolBuilder(tool="umi_reformat_fastq", base_command=["umi_reformat_fastq"], inputs=[ToolInput(tag="in_left", input_type=File(optional=True), prefix="--left", doc=InputDocumentation(doc="the input fastq file for r1. (default: None)")), ToolInput(tag="in_right", input_type=File(optional=True), prefix="--right", doc=InputDocumentation(doc="the input fastq file for r2. (default: None)")), ToolInput(tag="in_left_out", input_type=File(optional=True), prefix="--left-out", doc=InputDocumentation(doc="the output fastq file for r1 (default: None)")), ToolInput(tag="in_right_out", input_type=File(optional=True), prefix="--right-out", doc=InputDocumentation(doc="the output fastq file for r2 (default: None)")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Also include detailed stats for UMI and padding usage\n(default: False)")), ToolInput(tag="in_umi_locator", input_type=String(optional=True), prefix="--umi-locator", doc=InputDocumentation(doc="Set the UMI locators. If you have multiple, separate\nthem by comma. e.g. GGG,TCA,ATC (default: GGG,TCA,ATC)")), ToolInput(tag="in_umi_padding", input_type=String(optional=True), prefix="--umi-padding", doc=InputDocumentation(doc="Set the nucleotide (for preventing ligation bias)\nafter the UMI locators. If you have multiple, separate\nthem by comma. e.g. A,C,G,T. The quality for this nt\nis sometimes low, so the default is all possible four\nnucleotides (default: A,C,G,T,N)")), ToolInput(tag="in_umi_pattern", input_type=String(optional=True), prefix="--umi-pattern", doc=InputDocumentation(doc="Set the UMI patterns. (default: None)")), ToolInput(tag="in_quality", input_type=File(optional=True), prefix="--quality", doc=InputDocumentation(doc="Quality (phred quality score) cutoff for UMI.Default\nis 13, that is UMI with qualities >= 13 willbe kept.\nThis program assumes the phred quality scoresin the\nfastq file are using sanger format (default: 13)")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="Turn on debugging mode (default: False)"))], outputs=[ToolOutput(tag="out_left_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_left_out", type_hint=File()), doc=OutputDocumentation(doc="the output fastq file for r1 (default: None)")), ToolOutput(tag="out_right_out", output_type=File(optional=True), selector=InputSelector(input_to_select="in_right_out", type_hint=File()), doc=OutputDocumentation(doc="the output fastq file for r2 (default: None)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Umi_Reformat_Fastq_V0_1_0().translate("wdl", allow_empty_container=True)

